## primer3 1.0b

=== src/Makefile ===
# ======================================================================
# (c) Copyright 1996,1997,1998,1999,2000,2001,2004,2006 Whitehead
# Institute for Biomedical Research, Steve Rozen, and Helen Skaletsky
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 
#    * Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following disclaimer
# in the documentation and/or other materials provided with the
# distribution.
#    * Neither the names of the copyright holders nor contributors may
# be used to endorse or promote products derived from this software
# without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# ======================================================================

# ======================================================================
# CITING PRIMER3
# 
# Steve Rozen and Helen J. Skaletsky (2000) Primer3 on the WWW for
# general users and for biologist programmers. In: Krawetz S, Misener S
# (eds) Bioinformatics Methods and Protocols: Methods in Molecular
# Biology. Humana Press, Totowa, NJ, pp 365-386.  Source code available
# at http://fokker.wi.mit.edu/primer3/.
# ======================================================================

MAX_PRIMER_LENGTH = 36

LDLIBS = -lm
CC      = gcc
O_OPTS  = -O2
WHITEHEAD_SPECIFIC_HACK = -include /usr/include/sys/types.h
CC_OPTS = -g -Wall -D__USE_FIXED_PROTOTYPES__ $(WHITEHEAD_SPECIFIC_HACK)
P_DEFINES = -DDPAL_MAX_ALIGN=$(MAX_PRIMER_LENGTH) -DMAX_PRIMER_LENGTH=$(MAX_PRIMER_LENGTH)

CFLAGS  = $(CC_OPTS) $(O_OPTS)
LDFLAGS = -g

# ======================================================================
# IMPORTANT: on MacOS X and some other Unix/Linux systems where
# static libraries are not routinely available, -static has to
# be removed.
LIBOPTS ='-static'

PRIMER_EXE = primer3_core

PRIMER_OBJECTS=primer3_main.o\
               primer3.o\
               oligotm.o\
               dpal_primer.o\
               format_output.o\
               boulder_input.o

EXES=$(PRIMER_EXE) ntdpal oligotm long_seq_tm_test

all: $(EXES)

clean:
	-rm *.o $(EXES) *~

$(PRIMER_EXE): $(PRIMER_OBJECTS)
	$(CC) $(LDFLAGS) -o $@ $(PRIMER_OBJECTS) $(LIBOPTS) $(LDLIBS)

# For use with the "testcenter" testing program (CenterLine Software
# Inc, http://www.centerline.com)
$(PRIMER_EXE).tc: $(PRIMER_OBJECTS) /usr/lib/debug/malloc.o
	proof $(CC) $(CFLAGS) -o $@ $(PRIMER_OBJECTS) $(LIBOPTS) $(LDLIBS)

ntdpal: ntdpal_main.o dpal.o
	$(CC) $(LDFLAGS) -o $@ ntdpal_main.o dpal.o

oligotm: oligotm_main.c oligotm.o
	$(CC) $(CFLAGS) -o $@ oligotm_main.c oligotm.o $(LIBOPTS) $(LDLIBS)

long_seq_tm_test: long_seq_tm_test_main.c oligotm.o
	$(CC) $(CFLAGS) -o $@ long_seq_tm_test_main.c oligotm.o $(LIBOPTS) $(LDLIBS)

boulder_input.o: boulder_input.c boulder_input.h primer3.h primer3_release.h dpal.h
	$(CC) -c $(CFLAGS) $(P_DEFINES) -o $@ boulder_input.c

dpal.o: dpal.c dpal.h primer3_release.h
	$(CC) -c $(CFLAGS) -o $@ dpal.c

dpal_primer.o: dpal.c dpal.h primer3_release.h
	$(CC) -c $(CFLAGS) $(P_DEFINES) -o $@ dpal.c

format_output.o: format_output.c primer3_release.h format_output.h primer3.h dpal.h
	$(CC) -c $(CFLAGS) $(P_DEFINES) -o $@ format_output.c

ntdpal_main.o: ntdpal_main.c dpal.h
	$(CC) -c $(CC_OPTS) -o $@ ntdpal_main.c
# We use CC_OPTS above rather than CFLAGS because
# gcc 2.7.2 crashes while compiling ntdpal_main.c with -O2

oligotm_main.o: oligotm_main.c oligotm.h
	$(CC) -c $(CFLAGS) -o $@ ntdpal_main.c

oligotm.o: oligotm.c oligotm.h primer3_release.h

primer3.o: primer3.c primer3.h primer3_release.h
	$(CC) -c $(CFLAGS) $(P_DEFINES) primer3.c

primer3_main.o: primer3_main.c primer3.h primer3_release.h dpal.h oligotm.h format_output.h
	$(CC) -c $(CFLAGS) $(P_DEFINES) primer3_main.c

primer_test: $(PRIMER_EXE)
	cd ../test; primer_test.pl

## primer3 1.1.1

=== src/Makefile ===
--- 
+++ 
@@ -45,48 +45,65 @@
 LDLIBS = -lm
 CC      = gcc
 O_OPTS  = -O2
-WHITEHEAD_SPECIFIC_HACK = -include /usr/include/sys/types.h
-CC_OPTS = -g -Wall -D__USE_FIXED_PROTOTYPES__ $(WHITEHEAD_SPECIFIC_HACK)
+CC_OPTS = -g -Wall -D__USE_FIXED_PROTOTYPES__
 P_DEFINES = -DDPAL_MAX_ALIGN=$(MAX_PRIMER_LENGTH) -DMAX_PRIMER_LENGTH=$(MAX_PRIMER_LENGTH)
 
 CFLAGS  = $(CC_OPTS) $(O_OPTS)
 LDFLAGS = -g
 
 # ======================================================================
-# IMPORTANT: on MacOS X and some other Unix/Linux systems where
-# static libraries are not routinely available, -static has to
-# be removed.
-LIBOPTS ='-static'
+# If you have trouble with library skew when moving primer3 executables
+# between systems, you might want to set LIBOPTS to -static
+LIBOPTS =
 
-PRIMER_EXE = primer3_core
+PRIMER_EXE      = primer3_core
+OLIGOTM_LIB     = liboligotm.a
+OLIGOTM_DYN_LIB = liboligotm.so.1.2.0
+LIBRARIES       = $(OLIGOTM_LIB)
+RANLIB          = ranlib
 
-PRIMER_OBJECTS=primer3_main.o\
-               primer3.o\
-               oligotm.o\
-               dpal_primer.o\
-               format_output.o\
-               boulder_input.o
+PRIMER_OBJECTS1=primer3_main.o\
+                primer3.o\
+                dpal_primer.o\
+                format_output.o\
+                boulder_input.o\
+
+PRIMER_OBJECTS=$(PRIMER_OBJECTS1) $(OLIGOTM_LIB)
+PRIMER_DYN_OBJECTS=$(PRIMER_OBJECTS1) $(OLIGOTM_DYN_LIB)
+# These are files generated by running ./primer3_core < ../example
+example_files=example.for example.rev example.int
 
 EXES=$(PRIMER_EXE) ntdpal oligotm long_seq_tm_test
 
-all: $(EXES)
+all: $(EXES) $(LIBRARIES)
 
-clean:
-	-rm *.o $(EXES) *~
+clean_src:
+	-rm -f *.o $(EXES) $(PRIMER_EXE).dyn *~ $(LIBRARIES) $(example_files)
+
+clean: clean_src
+	cd ../test/; make clean
+
+$(OLIGOTM_LIB): oligotm.o
+	ar rv $@ oligotm.o
+	$(RANLIB) $@
+
+$(OLIGOTM_DYN_LIB): oligotm.o
+	gcc -shared -W1,-soname,liboligotm.so.1 -o $(OLIGOTM_DYN_LIB) oligotm.o
 
 $(PRIMER_EXE): $(PRIMER_OBJECTS)
 	$(CC) $(LDFLAGS) -o $@ $(PRIMER_OBJECTS) $(LIBOPTS) $(LDLIBS)
 
-# For use with the "testcenter" testing program (CenterLine Software
-# Inc, http://www.centerline.com)
-$(PRIMER_EXE).tc: $(PRIMER_OBJECTS) /usr/lib/debug/malloc.o
-	proof $(CC) $(CFLAGS) -o $@ $(PRIMER_OBJECTS) $(LIBOPTS) $(LDLIBS)
+# For use with valgrind, which requires at lease one
+# dynamically linked library.  Automatic testing with
+# valgrind is not implemented at this point.
+$(PRIMER_EXE).dyn: $(PRIMER_DYN_OBJECTS)
+	$(CC) $(CFLAGS) -o $@ $(PRIMER_DYN_OBJECTS) $(LIBOPTS) $(LDLIBS)
 
 ntdpal: ntdpal_main.o dpal.o
 	$(CC) $(LDFLAGS) -o $@ ntdpal_main.o dpal.o
 
-oligotm: oligotm_main.c oligotm.o
-	$(CC) $(CFLAGS) -o $@ oligotm_main.c oligotm.o $(LIBOPTS) $(LDLIBS)
+oligotm: oligotm_main.c oligotm.h $(OLIGOTM_LIB)
+	$(CC) $(CFLAGS) -o $@ oligotm_main.c $(OLIGOTM_LIB) $(LIBOPTS) $(LDLIBS)
 
 long_seq_tm_test: long_seq_tm_test_main.c oligotm.o
 	$(CC) $(CFLAGS) -o $@ long_seq_tm_test_main.c oligotm.o $(LIBOPTS) $(LDLIBS)
@@ -108,9 +125,6 @@
 # We use CC_OPTS above rather than CFLAGS because
 # gcc 2.7.2 crashes while compiling ntdpal_main.c with -O2
 
-oligotm_main.o: oligotm_main.c oligotm.h
-	$(CC) -c $(CFLAGS) -o $@ ntdpal_main.c
-
 oligotm.o: oligotm.c oligotm.h primer3_release.h
 
 primer3.o: primer3.c primer3.h primer3_release.h
@@ -119,5 +133,7 @@
 primer3_main.o: primer3_main.c primer3.h primer3_release.h dpal.h oligotm.h format_output.h
 	$(CC) -c $(CFLAGS) $(P_DEFINES) primer3_main.c
 
-primer_test: $(PRIMER_EXE)
-	cd ../test; primer_test.pl
+primer_test: test
+
+test: $(PRIMER_EXE) ntdpal
+	cd ../test; make test

=== test/Makefile ===
# ======================================================================
# (c) Copyright 1996,1997,1998,1999,2000,2001,2004,2006 Whitehead
# Institute for Biomedical Research, Steve Rozen, and Helen Skaletsky
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 
#    * Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following disclaimer
# in the documentation and/or other materials provided with the
# distribution.
#    * Neither the names of the copyright holders nor contributors may
# be used to endorse or promote products derived from this software
# without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# ======================================================================

test: 
	cd ../src; make
	echo 'Testing Tm calcs'; perl oligotm_test.pl;
	echo 'Testing alignment calcs'; perl dpal_test.pl; 
	echo 'Testing primer3_core'; perl p3test.pl

clean:
	-rm -rf primer_list_tmp/*
	-rm -rf primer1_list_tmp/*
	-rm -f primer_global_err/*.tmp primer_global_err/*.tmp2 primer_global_err/*.bak
	-rm -f *.tmp *.bak *~
	-rm -f hyb_probe_only.for hyb_probe_only.int 
	-rm -f right_only.for right_only.rev left_only.for
	-rm -f pcr_primers_and_io.int pcr_primers_and_io.rev pcr_primers_and_io.for
	-rm -f pcr_primers.rev pcr_primers.for

## primer3 1.1.4

=== Makefile ===
# ======================================================================
# (c) Copyright 1996,1997,1998,1999,2000,2001,2004,2006,2007 Whitehead
# Institute for Biomedical Research, Steve Rozen, and Helen Skaletsky
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 
#    * Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following disclaimer
# in the documentation and/or other materials provided with the
# distribution.
#    * Neither the names of the copyright holders nor contributors may
# be used to endorse or promote products derived from this software
# without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# ======================================================================

# ======================================================================
# CITING PRIMER3
# 
# Steve Rozen and Helen J. Skaletsky (2000) Primer3 on the WWW for
# general users and for biologist programmers. In: Krawetz S, Misener S
# (eds) Bioinformatics Methods and Protocols: Methods in Molecular
# Biology. Humana Press, Totowa, NJ, pp 365-386.  Source code available
# at http://fokker.wi.mit.edu/primer3/.
# ======================================================================

MAX_PRIMER_LENGTH = 36

LDLIBS = -lm
CC      = gcc
O_OPTS  = -O2
CC_OPTS = -g -Wall -D__USE_FIXED_PROTOTYPES__
P_DEFINES = -DDPAL_MAX_ALIGN=$(MAX_PRIMER_LENGTH) -DMAX_PRIMER_LENGTH=$(MAX_PRIMER_LENGTH)

CFLAGS  = $(CC_OPTS) $(O_OPTS)
LDFLAGS = -g

# ======================================================================
# If you have trouble with library skew when moving primer3 executables
# between systems, you might want to set LIBOPTS to -static
LIBOPTS =

PRIMER_EXE      = primer3_core
OLIGOTM_LIB     = liboligotm.a
OLIGOTM_DYN_LIB = liboligotm.so.1.2.0
LIBRARIES       = $(OLIGOTM_LIB)
RANLIB          = ranlib

PRIMER_OBJECTS1=primer3_main.o\
                primer3.o\
                dpal_primer.o\
                format_output.o\
                boulder_input.o\

PRIMER_OBJECTS=$(PRIMER_OBJECTS1) $(OLIGOTM_LIB)
PRIMER_DYN_OBJECTS=$(PRIMER_OBJECTS1) $(OLIGOTM_DYN_LIB)
# These are files generated by running ./primer3_core < ../example
example_files=example.for example.rev example.int

EXES=$(PRIMER_EXE) ntdpal oligotm long_seq_tm_test

all: $(EXES) $(LIBRARIES)

clean_src:
	-rm -f *.o $(EXES) $(PRIMER_EXE).dyn *~ $(LIBRARIES) $(example_files)

clean: clean_src
	cd ../test/; make clean

$(OLIGOTM_LIB): oligotm.o
	ar rv $@ oligotm.o
	$(RANLIB) $@

$(OLIGOTM_DYN_LIB): oligotm.o
	gcc -shared -W1,-soname,liboligotm.so.1 -o $(OLIGOTM_DYN_LIB) oligotm.o

$(PRIMER_EXE): $(PRIMER_OBJECTS)
	$(CC) $(LDFLAGS) -o $@ $(PRIMER_OBJECTS) $(LIBOPTS) $(LDLIBS)

# For use with valgrind, which requires at lease one
# dynamically linked library.  Automatic testing with
# valgrind is not implemented at this point.
$(PRIMER_EXE).dyn: $(PRIMER_DYN_OBJECTS)
	$(CC) $(CFLAGS) -o $@ $(PRIMER_DYN_OBJECTS) $(LIBOPTS) $(LDLIBS)

ntdpal: ntdpal_main.o dpal.o
	$(CC) $(LDFLAGS) -o $@ ntdpal_main.o dpal.o

oligotm: oligotm_main.c oligotm.h $(OLIGOTM_LIB)
	$(CC) $(CFLAGS) -o $@ oligotm_main.c $(OLIGOTM_LIB) $(LIBOPTS) $(LDLIBS)

long_seq_tm_test: long_seq_tm_test_main.c oligotm.o
	$(CC) $(CFLAGS) -o $@ long_seq_tm_test_main.c oligotm.o $(LIBOPTS) $(LDLIBS)

boulder_input.o: boulder_input.c boulder_input.h primer3.h primer3_release.h dpal.h
	$(CC) -c $(CFLAGS) $(P_DEFINES) -o $@ boulder_input.c

dpal.o: dpal.c dpal.h primer3_release.h
	$(CC) -c $(CFLAGS) -o $@ dpal.c

dpal_primer.o: dpal.c dpal.h primer3_release.h
	$(CC) -c $(CFLAGS) $(P_DEFINES) -o $@ dpal.c

format_output.o: format_output.c primer3_release.h format_output.h primer3.h dpal.h
	$(CC) -c $(CFLAGS) $(P_DEFINES) -o $@ format_output.c

ntdpal_main.o: ntdpal_main.c dpal.h
	$(CC) -c $(CC_OPTS) -o $@ ntdpal_main.c
# We use CC_OPTS above rather than CFLAGS because
# gcc 2.7.2 crashes while compiling ntdpal_main.c with -O2

oligotm.o: oligotm.c oligotm.h primer3_release.h

primer3.o: primer3.c primer3.h primer3_release.h
	$(CC) -c $(CFLAGS) $(P_DEFINES) primer3.c

primer3_main.o: primer3_main.c primer3.h primer3_release.h dpal.h oligotm.h format_output.h
	$(CC) -c $(CFLAGS) $(P_DEFINES) primer3_main.c

primer_test: test

test: $(PRIMER_EXE) ntdpal
	cd ../test; make test

## primer3 2.2.3

=== src/Makefile ===
# ======================================================================
# (c) Copyright 1996,1997,1998,1999,2000,2001,2004,2006,2007,2008,2009
# Whitehead Institute for Biomedical Research, Steve Rozen, 
# Andreas Untergasser and Helen Skaletsky
# All rights reserved.
# 
#   This file is part of primer3, the libprimer3 library, the oligotm 
#   library and the dpal library.
#
#   Primer3 and the libraries above are free software; you can
#   redistribute them and/or modify them under the terms of the GNU
#   General Public License as published by the Free Software Foundation;
#   either version 2 of the License, or (at your option) any later
#   version.
#
#   This software is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this file (file gpl-2.0.txt in the source distribution); if
#   not, write to the Free Software Foundation, Inc., 51 Franklin St,
#   Fifth Floor, Boston, MA 02110-1301 USA
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# ======================================================================

# ======================================================================
# CITING PRIMER3
# 
# Steve Rozen and Helen J. Skaletsky (2000) Primer3 on the WWW for
# general users and for biologist programmers. In: Krawetz S, Misener S
# (eds) Bioinformatics Methods and Protocols: Methods in Molecular
# Biology. Humana Press, Totowa, NJ, pp 365-386.  Source code available
# from https://sourceforge.net/projects/primer3/
# ======================================================================

# For VALGRIND -- see end of this makefile for testing primer3_core
# with valgrind, a leak and memory access checker.
TESTOPTS= 
WINMAKE=mingw32-make

LDLIBS     = -lm
AR         = ar
CC         = gcc
CPP        = g++
O_OPTS     = -O2
CC_OPTS    = -g -Wall -D__USE_FIXED_PROTOTYPES__
P_DEFINES  =

CFLAGS  = $(CC_OPTS) $(O_OPTS)
LDFLAGS = -g

# ======================================================================
# If you have trouble with library skew when moving primer3 executables
# between systems, you might want to set LIBOPTS to -static
LIBOPTS =

ifeq ($(TESTOPTS),--windows)
	PRIMER_EXE      = primer3_core.exe
	NTDPAL_EXE	= ntdpal.exe
	NTTHAL_EXE	= ntthal.exe
	OLIGOTM_EXE	= oligotm.exe
	LONG_SEQ_EXE	= long_seq_tm_test.exe
else
	PRIMER_EXE      = primer3_core
	NTDPAL_EXE	= ntdpal
	NTTHAL_EXE	= ntthal
	OLIGOTM_EXE	= oligotm
	LONG_SEQ_EXE	= long_seq_tm_test
endif
LIBOLIGOTM      = liboligotm.a
LIBOLIGOTM_DYN  = liboligotm.so.1.2.0
LIBDPAL         = libdpal.a
LIBDPAL_DYN     = libdpal.a.so.1.0.0
LIBTHAL         = libthal.a
LIBTHAL_DYN     = libthal.a.so.1.0.0
LIBPRIMER3      = libprimer3.a
LIBPRIMER3_DYN  = libprimer3.so.1.0.0
LIBRARIES       = $(LIBPRIMER3) $(LIBDPAL) $(LIBTHAL) $(LIBOLIGOTM) 
DYNLIBS         = $(LIBPRIMER3_DYN) $(LIBDPAL_DYN) $(LIBTHAL_DYN) $(LIBOLIGOTM_DYN)
RANLIB          = ranlib

PRIMER_OBJECTS1=primer3_boulder_main.o\
                format_output.o\
                read_boulder.o\
                print_boulder.o 

PRIMER_OBJECTS=$(PRIMER_OBJECTS1) $(LIBRARIES)
PRIMER_DYN_OBJECTS=$(PRIMER_OBJECTS1) $(DYNLIBS)
# These are files generated by running ./primer3_core < ../example
example_files=example.for example.rev example.int

EXES=$(PRIMER_EXE) $(NTDPAL_EXE) $(NTTHAL_EXE) $(OLIGOTM_EXE) $(LONG_SEQ_EXE)

all: $(EXES) $(LIBRARIES)

clean_src:
ifeq ($(TESTOPTS),--windows)
	del /Q /F *.o $(EXES) *~ $(LIBRARIES) $(example_files) core ..\*~
else
	-rm -f *.o $(EXES) *~ $(LIBRARIES) $(DYNLIBS) $(example_files) core ../*~
endif

clean: clean_src
ifeq ($(TESTOPTS),--windows)
	cd ..\test & $(WINMAKE) clean TESTOPTS=$(TESTOPTS)
else
	cd ../test/; make clean
endif

$(LIBOLIGOTM): oligotm.o
	$(AR) rv $@ oligotm.o
	$(RANLIB) $@

$(LIBOLIGOTM_LIB): oligotm.o
	$(CC) -shared -W1,-soname,liboligotm.so.1 -o $(LIBOLIGOTM_DYN) oligotm.o

$(LIBDPAL): dpal_primer.o
	$(AR) rv $@ dpal_primer.o
	$(RANLIB) $@

$(LIBDPAL_DYN): dpal_primer.o
	$(CC) -shared -W1,-soname,libdpal.so.1 -o $(LIBDPAL_DYN_LIB) dpal_primer.o

$(LIBTHAL): thal_primer.o
	$(AR) rv $@ thal_primer.o
	$(RANLIB) $@

$(LIBTHAL_DYN): thal_primer.o
	$(CC) -shared -W1,-soname,libthal.so.1 -o $(LIBTHAL_DYN_LIB) thal_primer.o

$(LIBPRIMER3): libprimer3.o p3_seq_lib.o
	$(AR) rv $@ libprimer3.o p3_seq_lib.o
	$(RANLIB) $@

$(LIBPRIMER3_DYN): libprimer3.o p3_seq_lib.o
	$(CC) -shared -W1,-soname,liprimer3.so.1 -o $(LIBPRIMER3_DYN) libprimer3.o p3_seq_lib.o

$(PRIMER_EXE): $(PRIMER_OBJECTS)
	$(CPP) $(LDFLAGS) -o $@ $(PRIMER_OBJECTS) $(LIBOPTS) $(LDLIBS)

libprimer3.o: libprimer3.c libprimer3.h p3_seq_lib.h dpal.h thal.h oligotm.h
	$(CPP) -c $(CFLAGS) -Wno-deprecated $(P_DEFINES) -o $@ libprimer3.c

$(NTDPAL_EXE): ntdpal_main.o dpal.o
	$(CPP) $(LDFLAGS) -o $@ ntdpal_main.o dpal.o

$(NTTHAL_EXE): thal_main.o thal.o
	$(CPP) $(LDFLAGS) -o $@ thal_main.o thal.o $(LDLIBS)

$(OLIGOTM_EXE): oligotm_main.c oligotm.h $(LIBOLIGOTM)
	$(CPP) $(CFLAGS) -o $@ oligotm_main.c $(LIBOLIGOTM) $(LIBOPTS) $(LDLIBS)

$(LONG_SEQ_EXE): long_seq_tm_test_main.c oligotm.o
	$(CPP) $(CFLAGS) -o $@ long_seq_tm_test_main.c oligotm.o $(LIBOPTS) $(LDLIBS)

read_boulder.o: read_boulder.c read_boulder.h libprimer3.h dpal.h thal.h p3_seq_lib.h 
	$(CPP) -c $(CFLAGS) $(P_DEFINES) -o $@ read_boulder.c

print_boulder.o: print_boulder.c print_boulder.h libprimer3.h p3_seq_lib.h 
	$(CPP) -c $(CFLAGS) $(P_DEFINES) -o $@ print_boulder.c

dpal.o: dpal.c dpal.h
	$(CPP) -c $(CFLAGS) -o $@ dpal.c

# We use '-ffloat-store' on windows to prevent undesirable
# precision which may lead to differences in floating point results.
thal.o: thal.c thal.h
	$(CPP) -c $(CFLAGS) -ffloat-store -o $@ thal.c

p3_seq_lib.o: p3_seq_lib.c p3_seq_lib.h libprimer3.h
	$(CPP) -c $(CFLAGS) -o $@ p3_seq_lib.c

dpal_primer.o: dpal.c dpal.h
	$(CPP) -c $(CFLAGS) $(P_DEFINES) -o $@ dpal.c

thal_primer.o: thal.c thal.h
	$(CPP) -c $(CFLAGS) -ffloat-store $(P_DEFINES) -o $@ thal.c

format_output.o: format_output.c format_output.h libprimer3.h dpal.h thal.h p3_seq_lib.h 
	$(CPP) -c $(CFLAGS) $(P_DEFINES) -o $@ format_output.c

ntdpal_main.o: ntdpal_main.c dpal.h
	$(CPP) -c $(CC_OPTS) -o $@ ntdpal_main.c

thal_main.o: thal_main.c thal.h
	$(CPP) -c $(CFLAGS) -o $@ thal_main.c
# We use CC_OPTS above rather than CFLAGS because
# gcc 2.7.2 crashes while compiling ntdpal_main.c with -O2

oligotm.o: oligotm.c oligotm.h

primer3_boulder_main.o: primer3_boulder_main.c libprimer3.h dpal.h thal.h oligotm.h format_output.h print_boulder.h read_boulder.h
	$(CPP) -c $(CFLAGS) $(P_DEFINES) primer3_boulder_main.c

primer_test: test

test: $(PRIMER_EXE) $(NTDPAL_EXE) $(NTTHAL_EXE)
ifeq ($(TESTOPTS),--windows)
	cd ..\test & $(WINMAKE) TESTOPTS=$(TESTOPTS)
else
	cd ../test; make test
endif

# ======================================================================
# 
# VALGRIND INSTRUCTIONS.
# 
# These instructions work for linux, and run the 'memcheck'
# functionality of valgrind.  Tests will be _much_ slower
# when running with valgrind checks.
# 
# If necessary, get and install valgrind (should come with most
# Linux's, but you need valgrind >= 3.2.3)
# 
# In the src directory for primer3:
#  
# $ make clean
# 
# Re-complile without optimization and run the normal tests, does
# _not_ valgrind them:
#
# $ make O_OPTS=-O0 test  # The value of O_OPTS is Minus Oh Zero 
# 
# Run valgrind on a small example:
#
# $ valgrind --leak-check=yes --show-reachable=yes --log-file-exactly=p3vg ./primer3_core < ../example
#
# Check output in file p3vg 
#
# Note: Valgrind is at /usr/local/bin/valgrind at WI
# 
# OK, now for the real tests:
#
# $ cd ../test
# 
# Check valgrind path in p3test.pl, ntdpal_test.pl, and oligotm_test.pl
# and correct if necessary.  This code works under valgrind 3.2.3.
# 
# $ make TESTOPTS=--valgrind  # Remember, you have to be in test/
# 
# When the --valgrind flag is set, the perl test scripts grep for and
# display errors and leaks, but you need to ***look at the output** to
# see these and figure out which test caused the problem, so you can
# debug it.
#
# ======================================================================

=== test/Makefile ===
# ======================================================================
# (c) Copyright 1996,1997,1998,1999,2000,2001,2004,2006,2007,2008,2009,
#       2010
# Whitehead Institute for Biomedical Research, Steve Rozen, 
# Andreas Untergasser and Helen Skaletsky
# All rights reserved.
# 
#   This file is part of primer3, the libprimer3 library, the oligotm 
#   library and the dpal library.
#
#   Primer3 and the libraries above are free software; you can
#   redistribute them and/or modify them under the terms of the GNU
#   General Public License as published by the Free Software Foundation;
#   either version 2 of the License, or (at your option) any later
#   version.
#
#   This software is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this file (file gpl-2.0.txt in the source distribution); if
#   not, write to the Free Software Foundation, Inc., 51 Franklin St,
#   Fifth Floor, Boston, MA 02110-1301 USA
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# ======================================================================

WINMAKE=mingw32-make

# See ../src/Makefile for detailed instructions on how to use TESTOPTS
# The only valid non-empty values for TESTOPTS are --valgrind and --windows
TESTOPTS =


test: makeexes testcmdline testtm testdpal testthal testcore test_io_v3

testcmdline:
ifeq ($(TESTOPTS),--windows)
	echo 'TESTING command line arguments' & perl cmdline_test.pl $(TESTOPTS)
else 
	echo; echo; echo 'TESTING command line arguments'; echo; perl cmdline_test.pl $(TESTOPTS)
endif

test_io_v3:
ifeq ($(TESTOPTS),--windows)
	cd io_version_3 & $(WINMAKE) test TESTOPTS=$(TESTOPTS)
else
	cd io_version_3; make test
endif

testcore:
ifeq ($(TESTOPTS),--windows)
	echo 'TESTING primer3_core' & perl p3test.pl $(TESTOPTS)
else
	echo; echo; echo 'TESTING primer3_core'; echo; perl p3test.pl $(TESTOPTS)
endif

testdpal:
ifeq ($(TESTOPTS),--windows)
	echo 'TESTING ALIGNMENT CALCS' & perl dpal_test.pl $(TESTOPTS)
else
	echo; echo; echo 'TESTING ALIGNMENT CALCS'; echo; perl dpal_test.pl $(TESTOPTS); 
endif

testthal:
ifeq ($(TESTOPTS),--windows)
	echo 'TESTING THERMODYNAMICAL ALIGNMENT CALCS' & perl thal_test.pl $(TESTOPTS)
else
	echo; echo; echo 'TESTING THERMODYNAMICAL ALIGNMENT CALCS'; echo; perl thal_test.pl $(TESTOPTS);
endif

testtm:
ifeq ($(TESTOPTS),--windows)
	echo 'TESTING Tm CALCS' & perl oligotm_test.pl $(TESTOPTS)
else
	echo; echo; echo 'TESTING Tm CALCS'; echo; perl oligotm_test.pl $(TESTOPTS);
endif

makeexes:
ifeq ($(TESTOPTS),--windows)
	cd ..\src & $(WINMAKE)
else
	cd ../src; make
endif

clean:
ifeq ($(TESTOPTS),--windows)
	echo 'CLEAN UP TEST DIRECTORIES'
	del /Q /F primer_list_tmp\*
	del /Q /F primer1_list_tmp\*
	del /Q /F primer_global_err\*.tmp primer_global_err\*.tmp2 primer_global_err\*.bak
	del /Q /F *.tmp *.bak *.tmp.err *~
	del /Q /F hyb_probe_only.for hyb_probe_only.int 
	del /Q /F right_only.for right_only.rev left_only.for
	del /Q /F pcr_primers_and_io.int pcr_primers_and_io.rev pcr_primers_and_io.for
	del /Q /F pcr_primers.rev pcr_primers.for
	del /Q /F syntax*.for syntax*.int syntax*.rev
	cd io_version_3 & $(WINMAKE) clean TESTOPTS=$(TESTOPTS)
else
	echo; echo; echo 'CLEAN UP TEST DIRECTORIES'; echo; echo;
	-rm -rf primer_list_tmp/*
	-rm -rf primer1_list_tmp/*
	-rm -f primer_global_err/*.tmp primer_global_err/*.tmp2 primer_global_err/*.bak
	-rm -f *.tmp *.bak *.tmp.err *~
	-rm -f hyb_probe_only.for hyb_probe_only.int 
	-rm -f right_only.for right_only.rev left_only.for
	-rm -f pcr_primers_and_io.int pcr_primers_and_io.rev pcr_primers_and_io.for
	-rm -f pcr_primers.rev pcr_primers.for
	-rm -f syntax[0-1][0-9].for syntax[0-1][0-9].int syntax[0-1][0-9].rev
	-rm -f oligotm.*.valg    # valgrind output from oligotm_test.pl --valgrind
	-rm -f ntdpal.*.valg     # valgrind output from dpal_test.pl --valgrind
	-rm -f ntthal.*.valg     # valgrind output from thal_test.pl --valgrind
	-rm -f oligotm.*.valg.*  # valgrind output from oligotm_test.pl --valgrind
	-rm -f ntdpal.*.valg.*   # valgrind output from dpal_test.pl --valgrind
	-rm -f ntthal.*.valg.*   # valgrind output from thal_test.pl --valgrind
	-rm -f *.vg */*.vg       # valgrind output from p3test{,z}.pl --valgrind
	-rm -f *.vg.core.*       # core files from crashed valgrind test
	-rm -f ./core # in case we crashed and left a core file
	cd io_version_3; make clean
endif

=== debian/changelog ===
primer3 (2.2.3-1) unstable; urgency=low

  * New upstream version
  * debian/primer3.docs: s/README.txt/primer3_manual.htm/
  * debian/compat: 7
  * debian/control:
    - Build-Depends: debhelper (>= 7)
    - Standards-Version: 3.9.1 (no changes needed
  * debian/source/format: 3.0 (quilt)
  * debian/README.source
  * debian/primer3.doc-base

 -- Andreas Tille <tille@debian.org>  Wed, 17 Nov 2010 14:01:59 +0100

primer3 (1.1.4-2) UNRELEASED; urgency=low

  [ David Paleino ]
  * Removed myself from Uploaders

  [ Charles Plessy ]
  * Documented informations in ‘debian/upstream-metadata.yaml’.
  * Removed mention of the bibliographic reference and the webservice in
    ‘debian/control’.

 -- David Paleino <d.paleino@gmail.com>  Sat, 23 May 2009 14:47:37 +0200

primer3 (1.1.4-1) unstable; urgency=low

  * New upstream release (No changes on Linux systems).
  * Updated my email address (debian/control, debian/copyright, manpages).
  * Updated the manpages:
    - using DocBook 4.5
    - incremented Primer3 version to 1.1.4

 -- Charles Plessy <plessy@debian.org>  Fri, 09 May 2008 12:54:28 +0900

primer3 (1.1.3-1) unstable; urgency=low

  [ Charles Plessy ]
  * New upstream version:
    - 1.1.3: Corrected static buffer overflow errors in
      boulder_print_pairs() and boulder_print_oligos() in primer3_main.c.
    - 1.1.2: Updates to dpal.c so that no error forces an exit.
      Adpatation in primer3_main.c and ntdpal_main.c to
        updated error handling in dpal().
      Arranged for primer3_main.c align() to check for
        and circumvent local alignments to "targets" < 3 nucleotides
        long, and added tests for this condition.
      Comment and code readability updates in dpal.h and dpal.c
  * Moved the Homepage: field out from the package's description.
  * debian/control: updated Steffen's email address.
  * debian/*.1.xml: corrected the headers of the sources of manpages.
  * debian/rules: converted to CDBS.

  [ David Paleino ]
  * debian/ntdpal.1, debian/primer3_core.1 and debian/oligotm.1
    added - manpages are statically built now
  * debian/control:
    - B-D updated
    - added myself to Uploaders
  * Updated to Standards-Version 3.7.3 (no changes needed)

 -- Charles Plessy <charles-debian-nospam@plessy.org>  Mon, 25 Feb 2008 16:31:58 +0900

primer3 (1.1.1-1) unstable; urgency=low

  * New upstream release.
  * Enhances: emboss because EMBOSS has a wrapper for primer3_core.
  * Add Subversion repository URL to debian/control.
  * Updated the manpages

 -- Charles Plessy <charles-debian-nospam@plessy.org>  Sun,  3 Jun 2007 16:16:19 +0900

primer3 (1.1.0~beta-1) experimental; urgency=low

  * New upstream release.
    - Some part of primer3 is now licenced under the GNU GPL.
    - The oligtotm() function is now provided as a library, liboligotm.
    - The oligotm executable now takes additional arguments.
    - Non-backward compatible change: removed support of flag -2x_compat.
  * Added a watch file now that the sources are hosted on SourceForge.net.
  * Updated manpages.

 -- Charles Plessy <charles-debian-nospam@plessy.org>  Sun, 18 Feb 2007 09:04:16 +0900

primer3 (1.0b-1) unstable; urgency=low

  * Initial release. (Closes: #241235)
  * New upstream version released under a revised BSD licence.
  * Swiching to collaborative maintainance: Maintainer is a mailing-list,
    Uploaders are real people.
  * Using debhelper v5 and conforming to policy 3.7.2.
  * Relicencing the manpage of Primer3 (thanks to Steffen Moeller), adding one
    for ntdpal and oligotm.
  * Extensive tests during bulding, except on slow architectures.

 -- Charles Plessy <charles-debian-nospam@plessy.org>  Thu, 28 Sep 2006 20:18:54 +0900

primer3 (0.9-0.2) unstable; urgency=low
  
  * Contacted upstream author, change of section to non-free/optional.

 -- Steffen Moeller <moeller@pzr.uni-rostock.de>  Wed,  1 Apr 2004 15:07:10 +0200
 

primer3 (0.9-0.1) unstable; urgency=low

  * Pre-Release.

 -- Steffen Moeller <moeller@pzr.uni-rostock.de>  Wed, 31 Mar 2004 15:07:10 +0200

=== debian/control ===
Source: primer3
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Steffen Moeller <moeller@debian.org>,
 Charles Plessy <plessy@debian.org>,
 Andreas Tille <tille@debian.org>
Build-Depends: debhelper (>= 7), cdbs
Standards-Version: 3.9.1
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/primer3/trunk/?rev=0&sc=0
Vcs-Svn: svn://svn.debian.org/svn/debian-med/trunk/packages/primer3/trunk/
Homepage: http://primer3.sourceforge.net

Package: primer3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends} 
Suggests: ncbi-epcr
Enhances: emboss
Description: Tool to design flanking oligo nucleotides for DNA amplification
 Primer3 picks primers for Polymerase Chain Reactions (PCRs), considering as
 criteria oligonucleotide melting temperature, size, GC content and
 primer-dimer possibilities, PCR product size, positional constraints within
 the source sequence, and miscellaneous other constraints. All of these
 criteria are user-specifiable as constraints, and some are specifiable as
 terms in an objective function that characterizes an optimal primer pair.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/class/makefile.mk
include /usr/share/cdbs/1/rules/debhelper.mk

DEB_MAKE_CHECK_TARGET   = -C test test
DEB_MAKE_CLEAN_TARGET   = -C src clean
DEB_MAKE_BUILD_TARGET   = -C src all

clean::
	$(MAKE) -C test clean

=== debian/watch ===
version=3
http://sf.net/primer3/primer3-([\d.]*)\.tar\.gz

## primer3 2.3.2

=== src/Makefile ===
--- 
+++ 
@@ -61,6 +61,8 @@
 
 CFLAGS  = $(CC_OPTS) $(O_OPTS)
 LDFLAGS = -g
+# Note, for profiling, use
+# make O_OPTS='-pg -O0' LDFLAGS='-g -pg'
 
 # ======================================================================
 # If you have trouble with library skew when moving primer3 executables

=== test/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # ======================================================================
 # (c) Copyright 1996,1997,1998,1999,2000,2001,2004,2006,2007,2008,2009,
-#       2010
+#       2010,2011
 # Whitehead Institute for Biomedical Research, Steve Rozen, 
 # Andreas Untergasser and Helen Skaletsky
 # All rights reserved.
@@ -45,12 +45,13 @@
 
 
 test: makeexes testcmdline testtm testdpal testthal testcore test_io_v3
+	echo; echo; echo "Testing completed. You must check the test output for the string FAILED"; echo; echo;
 
 testcmdline:
 ifeq ($(TESTOPTS),--windows)
-	echo 'TESTING command line arguments' & perl cmdline_test.pl $(TESTOPTS)
+	perl cmdline_test.pl $(TESTOPTS)
 else 
-	echo; echo; echo 'TESTING command line arguments'; echo; perl cmdline_test.pl $(TESTOPTS)
+	perl cmdline_test.pl $(TESTOPTS)
 endif
 
 test_io_v3:
@@ -76,16 +77,16 @@
 
 testthal:
 ifeq ($(TESTOPTS),--windows)
-	echo 'TESTING THERMODYNAMICAL ALIGNMENT CALCS' & perl thal_test.pl $(TESTOPTS)
+	echo 'TESTING THERMODYNAMIC ALIGNMENT CALCS' & perl thal_test.pl $(TESTOPTS)
 else
-	echo; echo; echo 'TESTING THERMODYNAMICAL ALIGNMENT CALCS'; echo; perl thal_test.pl $(TESTOPTS);
+	echo; echo; echo 'TESTING THERMODYNAMIC ALIGNMENT CALCS'; echo; perl thal_test.pl $(TESTOPTS);
 endif
 
 testtm:
 ifeq ($(TESTOPTS),--windows)
-	echo 'TESTING Tm CALCS' & perl oligotm_test.pl $(TESTOPTS)
+	perl oligotm_test.pl $(TESTOPTS)
 else
-	echo; echo; echo 'TESTING Tm CALCS'; echo; perl oligotm_test.pl $(TESTOPTS);
+	perl oligotm_test.pl $(TESTOPTS)
 endif
 
 makeexes:
@@ -98,26 +99,34 @@
 clean:
 ifeq ($(TESTOPTS),--windows)
 	echo 'CLEAN UP TEST DIRECTORIES'
+	del /Q /F primer1_list_tmp\*
+	del /Q /F primer1_th_list_tmp\*
 	del /Q /F primer_list_tmp\*
-	del /Q /F primer1_list_tmp\*
+	del /Q /F th-w-other-tasks_list_tmp\*
 	del /Q /F primer_global_err\*.tmp primer_global_err\*.tmp2 primer_global_err\*.bak
 	del /Q /F *.tmp *.bak *.tmp.err *~
 	del /Q /F hyb_probe_only.for hyb_probe_only.int 
 	del /Q /F right_only.for right_only.rev left_only.for
 	del /Q /F pcr_primers_and_io.int pcr_primers_and_io.rev pcr_primers_and_io.for
 	del /Q /F pcr_primers.rev pcr_primers.for
+	del /Q /F pick_primer_list_and_file_flag_th_*.for pick_primer_list_and_file_flag_th_*.rev
+	del /Q /F pick_primer_list_and_file_flag_th_*.int
 	del /Q /F syntax*.for syntax*.int syntax*.rev
 	cd io_version_3 & $(WINMAKE) clean TESTOPTS=$(TESTOPTS)
 else
 	echo; echo; echo 'CLEAN UP TEST DIRECTORIES'; echo; echo;
 	-rm -rf primer_list_tmp/*
 	-rm -rf primer1_list_tmp/*
+	-rm -rf primer1_th_list_tmp/*
+	-rm -rf th-w-other-tasks_list_tmp/*
 	-rm -f primer_global_err/*.tmp primer_global_err/*.tmp2 primer_global_err/*.bak
 	-rm -f *.tmp *.bak *.tmp.err *~
 	-rm -f hyb_probe_only.for hyb_probe_only.int 
 	-rm -f right_only.for right_only.rev left_only.for
 	-rm -f pcr_primers_and_io.int pcr_primers_and_io.rev pcr_primers_and_io.for
 	-rm -f pcr_primers.rev pcr_primers.for
+	-rm -f pick_primer_list_and_file_flag_th_[1-4].for pick_primer_list_and_file_flag_th_[1-4].rev
+	-rm -f pick_primer_list_and_file_flag_th_[1-4].int
 	-rm -f syntax[0-1][0-9].for syntax[0-1][0-9].int syntax[0-1][0-9].rev
 	-rm -f oligotm.*.valg    # valgrind output from oligotm_test.pl --valgrind
 	-rm -f ntdpal.*.valg     # valgrind output from dpal_test.pl --valgrind

=== debian/changelog ===
primer3 (2.3.2-1) unstable; urgency=low

  * New upstream release changing some default values.
  * Refreshed debian/copyright to machine-readable format version 1.0.
    Note that the license of Primer3 version 2.x changed to the GPLv2 or higher.
  * Spellchecked manual pages (Closes: #650477, thanks to A. Costa).
  * Using Debhelper 8 (debian/control, debian/compat).
  * Renamed debian/README.Debian debian/README.test as it is all about tests.
  * Conforms to Policy 3.9.3 (debian/control, no other changes needed).

 -- Charles Plessy <plessy@debian.org>  Thu, 22 Mar 2012 13:35:35 +0900

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
 Uploaders: Steffen Moeller <moeller@debian.org>,
  Charles Plessy <plessy@debian.org>,
  Andreas Tille <tille@debian.org>
-Build-Depends: debhelper (>= 7), cdbs
-Standards-Version: 3.9.1
+Build-Depends: debhelper (>= 8), cdbs
+Standards-Version: 3.9.3
 Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/primer3/trunk/?rev=0&sc=0
 Vcs-Svn: svn://svn.debian.org/svn/debian-med/trunk/packages/primer3/trunk/
 Homepage: http://primer3.sourceforge.net

## primer3 2.3.5

=== debian/changelog ===
primer3 (2.3.5-1) unstable; urgency=low

  New upstream release.

  [ Andreas Tille ]
  * debian/upstream:
     - Remove duplicated entry for PMID
     - Added Volume, fixed Number
     - Added URL+eprint
  * debian/control:
    - Removed DM-Upload-Allowed
    - Standards-Version: 3.9.4 (no changes needed)
  * debhelper 9 (control+compat)
  * debian/copyright: PD License should be avoided - bumped packaging
    to same license as program itself

 -- Andreas Tille <tille@debian.org>  Tue, 05 Feb 2013 10:11:37 +0100

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,13 @@
 Section: science
 Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-DM-Upload-Allowed: yes
 Uploaders: Steffen Moeller <moeller@debian.org>,
  Charles Plessy <plessy@debian.org>,
  Andreas Tille <tille@debian.org>
-Build-Depends: debhelper (>= 8), cdbs
-Standards-Version: 3.9.3
-Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/primer3/trunk/?rev=0&sc=0
-Vcs-Svn: svn://svn.debian.org/svn/debian-med/trunk/packages/primer3/trunk/
+Build-Depends: debhelper (>= 9), cdbs
+Standards-Version: 3.9.4
+Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/primer3/trunk/
+Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/primer3/trunk/
 Homepage: http://primer3.sourceforge.net
 
 Package: primer3

## primer3 2.3.6

=== src/Makefile ===
--- 
+++ 
@@ -71,15 +71,15 @@
 
 ifeq ($(TESTOPTS),--windows)
 	PRIMER_EXE      = primer3_core.exe
-	NTDPAL_EXE	= ntdpal.exe
-	NTTHAL_EXE	= ntthal.exe
-	OLIGOTM_EXE	= oligotm.exe
+	NTDPAL_EXE      = ntdpal.exe
+	NTTHAL_EXE      = ntthal.exe
+	OLIGOTM_EXE     = oligotm.exe
 	LONG_SEQ_EXE	= long_seq_tm_test.exe
 else
 	PRIMER_EXE      = primer3_core
-	NTDPAL_EXE	= ntdpal
-	NTTHAL_EXE	= ntthal
-	OLIGOTM_EXE	= oligotm
+	NTDPAL_EXE      = ntdpal
+	NTTHAL_EXE      = ntthal
+	OLIGOTM_EXE     = oligotm
 	LONG_SEQ_EXE	= long_seq_tm_test
 endif
 LIBOLIGOTM      = liboligotm.a

=== test/Makefile ===
--- 
+++ 
@@ -44,7 +44,7 @@
 TESTOPTS =
 
 
-test: makeexes testcmdline testtm testdpal testthal testcore test_io_v3
+test: makeexes testcmdline testtm testdpal testthal testcore
 	echo; echo; echo "Testing completed. You must check the test output for the string FAILED"; echo; echo;
 
 testcmdline:
@@ -52,13 +52,6 @@
 	perl cmdline_test.pl $(TESTOPTS)
 else 
 	perl cmdline_test.pl $(TESTOPTS)
-endif
-
-test_io_v3:
-ifeq ($(TESTOPTS),--windows)
-	cd io_version_3 & $(WINMAKE) test TESTOPTS=$(TESTOPTS)
-else
-	cd io_version_3; make test
 endif
 
 testcore:
@@ -112,7 +105,6 @@
 	del /Q /F pick_primer_list_and_file_flag_th_*.for pick_primer_list_and_file_flag_th_*.rev
 	del /Q /F pick_primer_list_and_file_flag_th_*.int
 	del /Q /F syntax*.for syntax*.int syntax*.rev
-	cd io_version_3 & $(WINMAKE) clean TESTOPTS=$(TESTOPTS)
 else
 	echo; echo; echo 'CLEAN UP TEST DIRECTORIES'; echo; echo;
 	-rm -rf primer_list_tmp/*
@@ -137,5 +129,4 @@
 	-rm -f *.vg */*.vg       # valgrind output from p3test{,z}.pl --valgrind
 	-rm -f *.vg.core.*       # core files from crashed valgrind test
 	-rm -f ./core # in case we crashed and left a core file
-	cd io_version_3; make clean
 endif

=== debian/changelog ===
primer3 (2.3.6-1) unstable; urgency=low

  [ Charles Plessy ]
  * New upstream release.
  * Install configuration files in /etc (first step to fix bug 702693).
  * Normalised debian/control with config-model-edit.
  * Use canonical VCS URLs.

  [ Andreas Tille ]
  * Fix watch file
  * replace cdbs by dh
  * debian/patches/hardening.patch: Propagate hardening options
  * Standards-Version: 3.9.5 (no changes needed)
  * debian/patches/primer_thermodynamic_parameters_path_2_etc.patch:
    Make sure config files will be searched for in /etc/primer3_config/
    instead of /opt/primer3_config/
    Closes: #702693
  * Verified that new upstream
    Closes: #716151, #716213 
  * New executable: ntthal (including manpage)
  * Removed *.xml variants of manpages to reduce redundancy

 -- Andreas Tille <tille@debian.org>  Thu, 19 Dec 2013 09:58:19 +0100

=== debian/control ===
Source: primer3
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>,
           Charles Plessy <plessy@debian.org>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.5
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/primer3/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/primer3/trunk/
Homepage: http://primer3.sourceforge.net

Package: primer3
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: ncbi-epcr
Enhances: emboss
Description: Tool to design flanking oligo nucleotides for DNA amplification
 Primer3 picks primers for Polymerase Chain Reactions (PCRs), considering as
 criteria oligonucleotide melting temperature, size, GC content and
 primer-dimer possibilities, PCR product size, positional constraints within
 the source sequence, and miscellaneous other constraints. All of these
 criteria are user-specifiable as constraints, and some are specifiable as
 terms in an objective function that characterizes an optimal primer pair.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --sourcedirectory=src

override_dh_auto_test:
	dh_auto_test --sourcedirectory=test

=== debian/watch ===
version=3
http://sf.net/primer3/primer3-[-src]*([\d.]*)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
